package at.or.at.plugoffairplane;

import android.app.IntentService;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.telephony.TelephonyManager;
import android.widget.Toast;
import eu.chainfire.libsuperuser.Shell;

public class BackgroundIntentService extends IntentService {

    public static final String ACTION_TURN_OFF_AIRPLANE_MODE = "at.or.at.plugoffairplane.action.TURN_OFF_AIRPLANE_MODE";

    public static void turnOffAirplaneMode(Context context) {
        if (context == null) {
            return;
        }

        Intent intent = new Intent(context, BackgroundIntentService.class);
        intent.setAction(ACTION_TURN_OFF_AIRPLANE_MODE);
        context.startService(intent);
    }

    public BackgroundIntentService() {
        super("BackgroundIntentService");
    }

    @Override
    protected void onHandleIntent(Intent intent) {
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(this);
        TelephonyManager telephony = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
        if (telephony != null && telephony.isNetworkRoaming() && !prefs.getBoolean("pref_enabled_on_roaming", true)) {
            Toast.makeText(this, R.string.roaming_toast_msg, Toast.LENGTH_LONG).show();
        }
        if (intent != null
                && ACTION_TURN_OFF_AIRPLANE_MODE.equals(intent.getAction())
                && prefs.getBoolean("pref_enabled", true)) {
            Shell.SU.run("settings put global airplane_mode_on 0");
            Shell.SU.run("am broadcast -a android.intent.action.AIRPLANE_MODE --ez state false");
        }
    }
}
